addHook("PlayerThink", function(player)
	if player.mo.skin ~= "treesonic" return end
	if player.flying == nil
		player.flying = false
	end
	if player.prevz == nil
		player.prevz = player.mo.z
	end
	if not player.powers[pw_pushing]
		player.prevz = player.mo.z
	end
	if not P_IsObjectOnGround(player.mo)
	and player.powers[pw_pushing]
		P_SetObjectMomZ(player.mo, 0*FRACUNIT, false)
		player.mo.z = player.prevz
		player.flying = true
		if player.pflags & PF_JUMPED
			player.pflags = $ & ~PF_JUMPED
		end
	end
	if (player.cmd.buttons & BT_JUMP)
	and not P_IsObjectOnGround(player.mo)
	and player.flying
		P_DoJump(player, true)
		player.flying = false
	end
	if (player.cmd.buttons & BT_USE)
	and not P_IsObjectOnGround(player.mo)
	and player.flying
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_STARTDASH)
	and (player.charability2 & CA2_SPINDASH)
		if player.speed > 5*FRACUNIT
			player.pflags = $|PF_SPINNING
			player.mo.state = S_PLAY_ROLL
			S_StartSound(player.mo, sfx_spin)
		end
	end
	if player.flying
	and not (player.powers[pw_carry] or player.playerstate == PST_DEAD or P_PlayerInPain(player))
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_STARTDASH)
		if player.speed == 0*FRACUNIT
			player.mo.state = S_PLAY_STND
		elseif player.speed < skins[player.mo.skin].runspeed
		and player.speed ~= 0*FRACUNIT
		and player.mo.state ~= S_PLAY_WALK
			player.mo.state = S_PLAY_WALK
		elseif player.speed >= skins[player.mo.skin].runspeed
		and player.mo.state ~= S_PLAY_RUN
			player.mo.state = S_PLAY_RUN
		end
	end
	if player.flying
	and player.speed < 6*FRACUNIT
	and (player.pflags & PF_SPINNING)
		player.pflags = $ & ~PF_SPINNING
	end
end)